// Configuration.h

#ifndef CONFIGURATION_H
#define CONFIGURATION_H

namespace WaveSoftware
{

   class Platform;

   class Configuration
   {
   public:
      Configuration();
      ~Configuration();

   public:
      void SetName(const std::string& name);
      void SetTitle(const std::string& title);
      void SetCopyright(const std::string& copyright);
      void SetDetailsRoot(const std::string& detailsroot);
      void SetRegistryKey(const std::string& registrykey);
      void SetPlatform(Platform* platform);

   public:
      const std::string& GetName();
      const std::string& GetTitle();
      const std::string& GetCopyright();
      const std::string& GetDetailsRoot();
      const std::string& GetRegistryKey();
      const Platform* GetPlatform();

   private:
      std::string m_Name;
      std::string m_Title;
      std::string m_Copyright;
      std::string m_DetailsRoot;
      std::string m_RegistryKey;
      Platform* m_Platform;
   };
   
}; // end of namespace

#endif // CONFIGURATION_H
