//---------------------------------------------------------------------------

#include "stdafx.h"
#pragma hdrstop

#include "ConfigurationFactory.h"
#include "Configuration.h"
#include "FixedFileInfo.h"
#include "Constants.h"
#include "Util.h"

USERES("ECheckLite.res");
USEFORM("Mainframe.cpp", frmMainframe);
USEUNIT("Test.cpp");
USEUNIT("Util.cpp");
USEUNIT("Constants.cpp");
USEUNIT("FreeDiskSpace.cpp");
USEUNIT("MDAC.cpp");
USEUNIT("mdacver_tlb.cpp");
USEUNIT("Version.cpp");
USEUNIT("FixedFileInfo.cpp");
USEFORM("About.cpp", dlgAbout);
USELIB("D:\borland\cb5\Lib\PSDK\shlwapi.lib");
USEUNIT("Configuration.cpp");
USEUNIT("ConfigurationFactory.cpp");
USEUNIT("NetworkCard.cpp");
USEUNIT("TestFactory.cpp");
USEUNIT("Platform.cpp");
USEUNIT("CpuSpeed.cpp");
USEUNIT("Ram.cpp");
USEUNIT("RegistryFile.cpp");
USEUNIT("ServicePack.cpp");
USEUNIT("SystemFile.cpp");
USELIB("cpuinf32.lib");
//---------------------------------------------------------------------------
using namespace WaveSoftware;

void Usage();
std::string GetUsage();
void Error();

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		Application->Initialize();

      if((0 == ParamCount()) || (ParamCount() > 2))
      {
			Usage();
         return(1);
      }

      TCHAR* confile = NULL;
		if(1 == ParamCount())
      	confile = ParamStr(1).c_str();
      else
      {
      	g_DebugPlatformEnabled = true;
         g_DebugPlatform = ParamStr(1).c_str();
         confile = ParamStr(2).c_str();
      }

      // To validate the configuration file, we create the in-memory
      // representation now.  We'll do this again in TfrmMainframe::Create.

      Configuration* config = ConfigurationFactory::Create(confile);

      if(NULL == config)
      {
      	Error();
         return(2);
      }

      delete config;  config = NULL;

		Application->CreateForm(__classid(TfrmMainframe), &frmMainframe);
		Application->CreateForm(__classid(TdlgAbout), &dlgAbout);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	return 0;
}
//---------------------------------------------------------------------------
void Usage()
{
   ::MessageBox((HWND) NULL,
   	GetUsage().c_str(),
		CSTR_INFORMATION.c_str(),
      MB_ICONINFORMATION | MB_OK);
}

void Error()
{
	std::string msg =
   	CSTR_BAD_COMMAND_LINE.c_str(),
      GetUsage();

   ::MessageBox((HWND) NULL,
   	msg.c_str(),
      CSTR_ERROR.c_str(),
      MB_ICONSTOP | MB_OK);
}

std::string GetUsage()
{
	FixedFileInfo ffi;

   ffi.SetPathname(Application->ExeName.c_str());

   std::string msg =
   	CSTR_ECHECKLITE_EXE +
      CSTR_SPACE +
      CSTR_HYPHEN +
      CSTR_SPACE +
      CSTR_ECHECKLITE_LONG +
      CSTR_SPACE +
      CSTR_VERSION +
      CSTR_SPACE +
      ffi.GetFileVersion().ToString() +
      CSTR_NEWLINE +
      CSTR_USAGE +
      CSTR_SPACE +
      CSTR_ECHECKLITE_EXE +
      CSTR_SPACE +
      CSTR_DEBUG_PLATFORM +
      CSTR_SPACE +
      CSTR_CONFIGURATION_FILE;

   return(msg);
}
