// NetworkCard.cpp

#include "stdafx.h"
#pragma hdrstop

#include "NetworkCard.h"
#include "Constants.h"
#include <nb30.h>

namespace WaveSoftware
{

typedef struct tagASTAT
{
   ADAPTER_STATUS status;
   NAME_BUFFER    name[30];
} ASTAT, *PASTAT;

NetworkCard::NetworkCard() :
      Test()
{
}

NetworkCard::~NetworkCard()
{
}

bool NetworkCard::Initialize(const StringMap& data)
{
   if(!(Test::Initialize(data)))
      return(false);

   return(true);
}

bool NetworkCard::Verify()
{
   NCB ncb;
   LANA_ENUM lenum;
   TCHAR netname[50];
   ASTAT adapter;
   UCHAR r = 0;

   SetStatus(TS_HIGH);
   SetStatusMsg(CSTR_UNDETECTED);

   ::ZeroMemory(&ncb, sizeof(NCB));

   ncb.ncb_command = NCBENUM;
   ncb.ncb_buffer  = (UCHAR*) &lenum;
   ncb.ncb_length  = sizeof(lenum);

   r = ::Netbios(&ncb);

   for(int i = 0; i < lenum.length; i++)
   {
      ::ZeroMemory(&ncb, sizeof(NCB));

      ncb.ncb_command  = NCBRESET;
      ncb.ncb_lana_num = lenum.lana[i];

      r = ::Netbios(&ncb);

      ::ZeroMemory(&ncb, sizeof(NCB));

      ncb.ncb_command = NCBASTAT;
      ncb.ncb_lana_num = lenum.lana[i];

      _tcscpy((TCHAR*) ncb.ncb_callname, CSTR_ASTERISK.c_str());
      ncb.ncb_buffer = (UCHAR*) &adapter;
      ncb.ncb_length = sizeof(adapter);

      r = ::Netbios(&ncb);

      if(NRC_GOODRET == r)
      {
         // At least one network card exists and has a valid MAC accress.
         SetStatus(TS_OK);
         SetStatusMsg(CSTR_DETECTED);

         break;
      }
   }
   
   return(true);
}

} // end of namespace

