// Ram.cpp

#include "stdafx.h"
#pragma hdrstop

#include "Ram.h"
#include "Util.h"
#include "Constants.h"
#include <sstream>

namespace WaveSoftware
{

   Ram::Ram()
   {
      m_Minimum = 0;
      m_Recommended = 0;
   }

   Ram::~Ram()
   {
   }

   bool Ram::Initialize(const StringMap& data)
   {
      if(!(Test::Initialize(data)))
         return(false);

      if(!(Util::GetFromMap(data, CSTR_MINIMUM, m_Minimum)))
         return(false);

      if(!(Util::GetFromMap(data, CSTR_RECOMMENDED, m_Recommended)))
         return(false);

      return(true);
   }

   bool Ram::Verify()
   {
      SetStatus(TS_HIGH);
      SetStatusMsg(CSTR_UNKNOWN);

      MEMORYSTATUS ms;

      ::ZeroMemory(&ms, sizeof(MEMORYSTATUS));

      ms.dwLength = sizeof(MEMORYSTATUS);

      ::GlobalMemoryStatus(&ms);

      int ram = ms.dwTotalPhys / (1000 * 1000);

      if(ram >= m_Recommended)
         SetStatus(TS_OK);
      else if((ram >= m_Minimum) && (ram < m_Recommended))
         SetStatus(TS_MED);

      std::stringstream ss;

      ss << CSTR_TILDE << ram << CSTR_MEGABYTES;

      SetStatusMsg(ss.str());
         
      return(true);
   }

} // end of namespace
